﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=8.5
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: True
#End Region

Sub Process_Globals

	Dim TTS1 As TTS					'lib TTS
	'Dim VR As VoiceRecognition		'lib Phone
    Dim SR As SpeechToText			'lib SpeechToText https://www.b4x.com/android/forum/threads/another-speechrecognizer-library.37584/
    Dim SRri As RecognizerIntent
    Dim SRi As Intent
	Dim ph As Phone					'lib Phone
	Dim PE As PhoneEvents			'lib Phone - need for PE_TextToSpeechFinish
	Dim mPhId As PhoneId			'          - need for PE_TextToSpeechFinish
	Dim gstrUserListLinked As String
	Dim gintLinkOrCopyType As Int
	Dim const LINKORCOPYTYPE_COPYITEM As Int = 0
	Dim const LINKORCOPYTYPE_LINKITEM As Int = 1
	Dim const LINKORCOPYTYPE_LINKLIST As Int = 2
	Dim const LINKORCOPYTYPE_ADDANDLINKITEM As Int = 3
	
	Dim const QU_END As Int = 0
	Dim const QU_NOTE As Int = 3
	Dim const QU_CONFNOTE As Int = 4
	Dim const QU_STAYOPEN As Int = 99

End Sub

Sub Globals
	
	Private lblUserRow As Label
	Private btnUserRowExtra As Button
	Private clvUserList As CustomListView
	Private lblDivider As Label
	Private mintDblclickIndex As Int
	Private mintPlaylistCnt As Int
	Private mintStartVolume As Int
	Private lblLinkInd As Label
	Private lblLinkIndDSWP As Label
	Private lblIndDSWPn As Label
	Private lblIndDSWPy As Label
	Private lblIndDSWPnL As Label
	Private lblIndDSWPyL As Label
	Private lblIndDSWPrL As Label
	Private clvPickList As CustomListView
	Private pnlPickList As Panel
	Private mblnPickListOpen As Boolean
	Private mbytWaitClick As Byte
	Private mblnCanVoiceAdd As Boolean
	Dim mintQuestionNo As Int
	Dim mstrMessage As String
	Dim mintStartVolume As Int
	Dim mstrSpeech_Record As String = "Recoard"		'spelling gets better pronunciation on glens S7
	Private pnlVolume As Panel
	Private skbVol As SeekBar

End Sub

Sub Activity_Create(FirstTime As Boolean)

	Dim mlrList As MainListRow

	Log("UserList_Activity_Create")
	Log("Main.glstSelectedLists.Size=" & Main.glstSelectedLists.Size)
	Log(Main.glstSelectedLists.Size)
	'started getting some odd timing issue with glstSelectedLists.Size>1. Log(glstSelectedLists.Size) on line above displays number, 
	'  but If test on line below crashes app. Tring sleep to solve.
	If Main.glstSelectedLists.Size = 1 Then
		mlrList = Main.glstSelectedLists.Get(0)
		mblnCanVoiceAdd = (mlrList.MasterList = "")
		PE.InitializeWithPhoneState("PE",  mPhId)
	End If

	' Only seems to show 3 buttons
	If mlrList.MasterList = "" Or Not(mlrList.MasterImm) Then
		Activity.AddMenuItem3("Add", "mnuAddNew", LoadBitmap(File.DirAssets, "ic_input_add.png"), True)
	Else	
		Activity.AddMenuItem3("Add from master", "mnuAddFromMaster", LoadBitmap(File.DirAssets, "ic_input_add.png"), True)
	End If
	If mblnCanVoiceAdd Then
		Activity.AddMenuItem3("VoiceAdd", "mnuVoiceAdd", LoadBitmap(File.DirAssets, "perm_group_voicemail.png"), True)			
		TTS1.Initialize("TTS1")
		'VR.Initialize("VR")
	    SR.initialize("SR")
		If Not(SR.isRecognitionAvailable) Then
			MsgboxAsync("Voice recognition not available", "Error")
			Wait For Msgbox_Result
			Activity.Finish
			Return
		End If
	    SRi.Initialize(SRri.ACTION_VOICE_SEARCH_HANDS_FREE,"")
	    SRi.PutExtra(SRri.EXTRA_CALLING_PACKAGE,"com.inforpires.testSpeech")
	    SRi.PutExtra(SRri.EXTRA_LANGUAGE_MODEL, SRri.LANGUAGE_MODEL_FREE_FORM)
	    'SRi.PutExtra(ri.EXTRA_LANGUAGE,"en_NZ")
	    SRi.PutExtra(SRri.EXTRA_MAX_RESULTS,1)
	    SRi.PutExtra(SRri.EXTRA_PARTIAL_RESULTS,True)
        SR.createSpeechRecognizer
	Else
		Activity.AddMenuItem3("Order", "mnuLoadListOrder", LoadBitmap(File.DirAssets, "ic_menu_sort_by_size.png"), True)
	End If
	If mlrList.MasterList <> "" And Not(mlrList.MasterImm) Then
		Activity.AddMenuItem3("Add from master", "mnuAddFromMaster", LoadBitmap(File.DirAssets, "ic_input_add.png"), True)
	End If
	If mlrList.MasterList <> "" Then
		Activity.AddMenuItem3("Edit master list", "mnuEditMaster", LoadBitmap(File.DirAssets, "ic_input_get.png"), True)
	End If
	Activity.AddMenuItem3("Modify list", "mnuModUserList", LoadBitmap(File.DirAssets, "ic_menu_sort_alphabetically.png"), True)
	Activity.AddMenuItem3("Link other list items", "mnuLinkItem", LoadBitmap(File.DirAssets, "ic_menu_attachment.png"), True)
	Activity.AddMenuItem3("Copy other list items", "mnuCopyItem", LoadBitmap(File.DirAssets, "ic_menu_copy.png"), True)
	Activity.AddMenuItem3("Link other list", "mnuLinkList", LoadBitmap(File.DirAssets, "ic_menu_attachment.png"), True)
	Activity.AddMenuItem3("Add and link to other list", "mnuAddAndLink", LoadBitmap(File.DirAssets, "ic_menu_attachment.png"), True)
	If mblnCanVoiceAdd Then
		Activity.AddMenuItem3("Set volume", "mnuSetVolume", LoadBitmap(File.DirAssets, "ic_volume.png"), True)	
	End If
	'Activity.AddMenuItem3("Undo", "mnuUndo", LoadBitmap(File.DirAssets, "ic_menu_revert.png"), True)
	
End Sub

Sub Activity_Resume

	LoadList("", 0)
	If mblnPickListOpen Then
		'reopen panel. can't leave it open as we reload layout
		LoadMenuLinkCopyItems(gintLinkOrCopyType = LINKORCOPYTYPE_COPYITEM Or gintLinkOrCopyType = LINKORCOPYTYPE_LINKITEM)
	End If
	If mblnCanVoiceAdd Then
		VolumeInitialise
	End If
	
End Sub

Sub Activity_Pause (UserClosed As Boolean)

	If UserClosed Then
		If mblnCanVoiceAdd Then
			SR.destroy
		End If
	End If
	
End Sub

Sub Activity_KeyPress (KeyCode As Int) As Boolean 'Return True to consume the event
	
	If KeyCode = KeyCodes.KEYCODE_BACK Then
		If pnlVolume.Visible Then
			pnlVolume.Visible = False
			Return True
		else if DismissPanels Then
			Return True
		End If
	End If
	Return False
	
End Sub

Sub btnUserRowExtra_Click

	Dim pnl As Panel = clvUserList.GetPanel(clvUserList.GetItemFromView(Sender))
	Dim lbl As Label = pnl.GetView(0)
	Dim btn As Button = pnl.GetView(1)
	Dim sl As SortList = lbl.Tag
	Dim mlr As MainListRow = Main.glstAllLists.Get(sl.SrcListNo)
	Dim strExtraFile As String
	Dim strText As String

	strExtraFile = Module1.ExtraFilename(mlr.ListNo, lbl.Text)
	If File.Exists(Starter.gstrDir, strExtraFile) Then
		strText = File.ReadString(Starter.gstrDir, strExtraFile)
	End If
	
	Wait For(libloc_MultilineInputDialog(strText, True)) Complete (strInput As String)
	If strInput = "" Then
		If File.Exists(Starter.gstrDir, strExtraFile) Then
			File.Delete(Starter.gstrDir, strExtraFile)
		End If
		btn.Text = ""
		'btn.TextColor = Colors.Gray
		'btn.Typeface = Typeface.DEFAULT_BOLD
	Else if strInput <> QUOTE Then
		File.WriteString(Starter.gstrDir, strExtraFile, strInput)
		If IsNumber(strInput) Then
			btn.Text = strInput
		Else
			btn.Text = ">"
			'btn.Typeface = Typeface.DEFAULT_BOLD
		End If
		btn.TextColor = Colors.Blue
	End If
	
End Sub

Sub clvPickList_ItemClick (Index As Int, Value As Object)
	
	pnlPickList.Visible = False
	Main.gstrSelectedList = Value
	If gintLinkOrCopyType = LINKORCOPYTYPE_LINKLIST Then
		Dim mlrTgt As MainListRow = Main.glstSelectedLists.Get(0)
		Dim strListName As String
		strListName = Value
		If strListName.IndexOf("{") >0 Then
			strListName = strListName.SubString2(0, strListName.IndexOf("{"))
		End If
		Dim mlrSrc As MainListRow = Module1.MainListRow_FromListName(strListName)
		Dim lstTgt As List = File.ReadList(Starter.gstrDir, Module1.ListFilename(mlrTgt.ListName))
		If lstTgt.IndexOf(mlrSrc.ListName & Chr(127) & mlrSrc.ListNo) < 0 Then
			lstTgt.InsertAt(0, mlrSrc.ListName & Chr(127) & mlrSrc.ListNo)
		End If
		File.WriteList(Starter.gstrDir, Module1.ListFilename(mlrTgt.ListName), lstTgt)
		LoadList("", 0)
	Else If gintLinkOrCopyType = LINKORCOPYTYPE_ADDANDLINKITEM Then
		strListName = Value
		If strListName.IndexOf("{") >0 Then
			strListName = strListName.SubString2(0, strListName.IndexOf("{"))
		End If
		AddAndLink(Value)
	Else
		StartActivity(LinkCopyUserList)
	End If

End Sub
'
' Rtn whether any panel was visible/dismissed
'
Sub DismissPanels As Boolean
	
	Dim blnRtn As Boolean

	If mblnPickListOpen Then			'using this as we reload activity and app thinks panel is not visible when it is
		pnlPickList.Visible = False
		mblnPickListOpen = False
		blnRtn = True
	End If
	Return blnRtn
	
End Sub

Sub Handleclick(pintIndex As Int)

	' Sort sngclick from dblclick
	If mbytWaitClick = 1 Then
		mbytWaitClick = 2
		mintDblclickIndex = pintIndex
		Return
	End If
	
	mbytWaitClick = 1
	Sleep (250)

	Dim pnl As Panel = clvUserList.GetPanel(pintIndex)
	Dim lbl As Label = pnl.GetView(0)
	Dim sl As SortList = lbl.Tag
	Dim mlr As MainListRow = Main.glstAllLists.Get(sl.SrcListNo)

	If sl.Item = mlr.ListName Then
		If mbytWaitClick = 1 Then
			' Linked listname
			If gstrUserListLinked <> "" Then	'don't want recursive
				Return
			End If
			gstrUserListLinked = mlr.ListName
			StartActivity(UserListLinked)
		End If
		Return
	End If
     
	If mbytWaitClick = 1 Then
		' Rename
		Dim strNewName As String
		strNewName = Module1.RenameItem(mlr, lbl.Text, sl.ListNo)
		If strNewName <> "" Then
			LoadList("", 0)
			'lbl.Text = strNewName
		End If
	Else
		' Pick
		If pintIndex = mintDblclickIndex Then
			PickItem(pintIndex)
		End If
	End If
	mbytWaitClick = 0

End Sub

Sub lblDivider_Click
	
	Handleclick(clvUserList.GetItemFromView(Sender))
	
End Sub
Sub lblDivider_LongClick
	
	RemoveItem(clvUserList.GetItemFromView(Sender), False)
	
End Sub

Sub lblUserRow_Click
	
	Handleclick(clvUserList.GetItemFromView(Sender))
	
End Sub
Sub lblUserRow_LongClick
	
	RemoveItem(clvUserList.GetItemFromView(Sender), False)
	
End Sub

Sub AddAndLink(pstrSrcList As String)

	Dim intInsertAt As Int 
	Dim intLoc As Int
	Dim strItem As String
	Dim strParts() As String
	Dim lstSrc As List
	Dim lstTgt As List
	Dim mlrTgt As MainListRow = Main.glstSelectedLists.Get(0)	'curr list linking from selected src
	Dim mlrSrc As MainListRow = Module1.MainListRow_FromListName(pstrSrcList)	'selected src


	Wait For(libloc_MultilineInputDialog("", False)) Complete (strInput As String)
	If strInput = "" Or strInput = QUOTE Then
		Return
	End If
	
	lstSrc = File.ReadList(Starter.gstrDir, Module1.ListFilename(mlrSrc.ListName))
	lstTgt = File.ReadList(Starter.gstrDir, Module1.ListFilename(mlrTgt.ListName))
	strParts = Regex.Split(CRLF, Module1.CleanItemName(strInput))
	For intCnt1 = strParts.Length-1 To 0 Step -1
		intInsertAt = 0
		strItem = Module1.CleanItemName(strParts(intCnt1))
		intLoc = strItem.LastIndexOf("..")			'can end .. or ..1|2 etc
		If intLoc > 0 Then	'And intLoc < strItem.Length-2 Then
			If intLoc = strItem.Length-2 Then
				intInsertAt = 999
				strItem = strItem.SubString2(0, intLoc)
			Else
				If IsNumber(strItem.SubString(intLoc+2)) Then
					intInsertAt = strItem.SubString(intLoc+2)
					If intInsertAt < 0 Then
						intInsertAt = 1
					else if intInsertAt > lstSrc.Size Then
						intInsertAt = 999
					End If
					strItem = strItem.SubString2(0, intLoc)
				End If
			End If
		End If	
		
		' Add new items to src list
		If lstSrc.IndexOf(strItem) < 0 Then
			If intInsertAt = 0 Then
				lstSrc.InsertAt(0, strItem)
			else if intInsertAt = 999 Then
				lstSrc.Add(strItem)
			Else
				lstSrc.InsertAt(intInsertAt-1, strItem)
			End If
		else if intInsertAt > 0 Then
			' Move existing item
			lstSrc.RemoveAt(lstSrc.IndexOf(strItem))
			If intInsertAt = 999 Then
				lstSrc.Add(strItem)
			Else
				lstSrc.InsertAt(intInsertAt-1, strItem)
			End If
		End If

		strItem = strItem & Chr(127) & mlrSrc.ListNo
		
		' Link items to curr list
		If lstTgt.Indexof(strItem) < 0 Then
			lstTgt.InsertAt(0, strItem)
		End If
	Next
	
	File.WriteList(Starter.gstrDir, Module1.ListFilename(mlrSrc.ListName), lstSrc)
	File.WriteList(Starter.gstrDir, Module1.ListFilename(mlrTgt.ListName), lstTgt)
	LoadList("", 0)
	
End Sub

Sub ListenForSpeech
	'VR.Listen
	LibGen.lib_ToastMessage("Listening...", 1000, Colors.Blue)
	'lblListening.Visible = True
	SR.startListening(SRi)
End Sub

Sub LoadList(pstrSelectItem As String, pintSelectListNo As Int)
	
	Dim blnHidePkdWhnRbldMultiLst As Boolean
	Dim blnOk As Boolean 
	Dim lstList As List
	Dim lstMaster As List
	Dim lstPicked As List
	Dim lstTemp As List
	Dim lstSelect As List
	Dim intCnt1 As Int
	Dim intCnt2 As Int
	Dim intLoc As Int 
	Dim intSelectedList As Int
	Dim strItem As String
	Dim strExtraFile As String
	Dim intSelectedIndex As Int = -1
	Dim pnl As Panel
	Dim mlrList As MainListRow			'list selected in main (this loop where multi)
	Dim mlrSource As MainListRow		'source list where item is a linked one
	Dim sl1 As SortList
	
	Activity.LoadLayout("Userlist")
	clvUserList.Clear
	'clvUserList.AddTextItem("Loading...", "")
	'Sleep(0)
	If Main.glstSelectedLists.Size > 1 Then
		Activity.Title = "Multi-list"
		blnHidePkdWhnRbldMultiLst = LibGen.lib_GetINIstring(False, "", "HidePkdWhnRbldMultiLst", True)
	Else
		mlrList = Main.glstSelectedLists.Get(0)
		Activity.Title = mlrList.ListAbbr
	End If
	
	lstList.Initialize
	lstTemp.Initialize
	For intSelectedList = 0 To Main.glstSelectedLists.Size-1
		mlrList = Main.glstSelectedLists.Get(intSelectedList)
		lstTemp = File.ReadList(Starter.gstrDir,  Module1.ListFilename(mlrList.ListName))
		lstPicked = File.ReadList(Starter.gstrDir,  Module1.PickedFilename(mlrList.ListName))
		If mlrList.MasterList <> "" Then
			lstMaster = File.ReadList(Starter.gstrDir, Module1.ListFilename(mlrList.MasterList))
		End If
		intCnt2 = lstTemp.Size-1

		' When in muliview, don't include items below row starting -- (that's where I put stuff on hold)
		If Main.glstSelectedLists.Size > 1 Then
			For intCnt1 = lstTemp.Size-1 To 0 Step -1
				strItem = lstTemp.Get(intCnt1)
				If strItem.StartsWith("--") Then
					intCnt2 = intCnt1 - 1
					Exit
				End If
			Next
		End If
		
		' Load lstList full of SortLists
		For intCnt1 = intCnt2 To 0 Step -1
			strItem = lstTemp.Get(intCnt1)
			blnOk = True
			Dim sl As SortList
			intLoc = strItem.IndexOf(Chr(127))	'is it a linked item
			If intLoc >= 0 Then
				' Linked item/listname
				sl.SrcListNo = strItem.SubString(intLoc+1)
				sl.ListNo = mlrList.ListNo
				sl.Item = strItem.SubString2(0, intLoc)
				
				' Check it still exists in source (provided not a linked listname)
				mlrSource = Main.glstAllLists.Get(sl.SrcListNo)
				If sl.Item <> mlrSource.ListName Then
					lstSelect = File.ReadList(Starter.gstrDir, Module1.ListFilename(mlrSource.ListName))
					If lstSelect.IndexOf(sl.Item) < 0 Then
						lstTemp.RemoveAt(intCnt1)
						File.WriteList(Starter.gstrDir, Module1.ListFilename(mlrList.ListName), lstTemp)
						blnOk = False
					End If
				End If
				
				' If this is a multilist, we don't want to show linked item if source list is included
				' But there are some whys and wherefores:
				' If, in the source list, the item is below -- it will be excluded, thus this linked item won't who either.
				' We could choose to not show any item if it in the list already. This could resulkt in the linked item showing (loaded first)
				' rather than the source item (that list loaded after).
				' Either way we don't want the same linked item in several lists showing up multiple times.
				' Going with, check linked item only
				'   (a) if source list included, exclude linked item
				'   (b) if source list not included, exclude if same linked item already in list
 				If Main.glstSelectedLists.Size > 1 Then
					For intCnt2 = 0 To Main.glstSelectedLists.Size-1
						mlrSource = Main.glstSelectedLists.Get(intCnt2)
						If sl.SrcListNo = mlrSource.ListNo Then
							blnOk = False
							Exit
						End If
					Next
					If blnOk Then
						For intCnt2 = 0 To lstList.Size-1
							sl1 = lstList.Get(intCnt2)
							If sl1.SrcListNo = sl.SrcListNo And sl1.Item = sl.Item Then
								blnOk = False
								Exit
							End If
						Next
					End If
				End If
			Else
				sl.ListNo = mlrList.ListNo
				sl.SrcListNo = mlrList.ListNo
				sl.Item = strItem
			End If
			
			If blnOk Then
				If mlrList.MasterList = "" Then
					sl.MasterIndex = -1
				Else
					sl.MasterIndex = lstMaster.IndexOf(sl.Item)
				End If
				' For multi-list, depending on Setting, remove picked items from list
				If Main.glstSelectedLists.Size > 1 And blnHidePkdWhnRbldMultiLst Then
					If Not(mlrList.DelSrcWhenPicked) Then
						If lstPicked.IndexOf(strItem) >= 0 Then
							blnOk = False
						End If
					End If
				End If
				If blnOk Then
					lstList.InsertAt(0, sl)		'use this as we are viewing list
					'lstList.Add(sl)			' in reverse order
				End If
			End If
		Next
	Next

	If Main.gblnListSortNumerically Then
		lstList.SortType("MasterIndex", True)
	Else
		lstList.SortType("Item", True)
	End If
	
	clvUserList.Clear
	For intCnt1 = 0 To lstList.Size-1
		pnl.Initialize("")
		pnl.SetLayout(0, 0, clvUserList.AsView.Width, 40dip) 'set the panel size before you load the layout.
		pnl.LoadLayout("Userrow")
		pnl.Color = Colors.White
		sl = lstList.Get(intCnt1)
		lblUserRow.Text = sl.Item 
		lblUserRow.Tag = sl
		mlrList = Main.glstAllLists.Get(sl.SrcListNo)
		lblUserRow.TextColor = Colors.RGB(mlrList.R, mlrList.G, mlrList.B)
		If sl.Item = pstrSelectItem And sl.SrcListNo = pintSelectListNo Then
			intSelectedIndex = intCnt1
		End If

		' Grey picked items from lists that don't remove picked items
		'If Main.glstSelectedLists.Size = 1 Then
			If Not(mlrList.DelSrcWhenPicked) Then
				lstPicked = File.ReadList(Starter.gstrDir, Module1.PickedFilename(mlrList.ListName))
				If lstPicked.IndexOf(sl.Item) >= 0 Then
					lblUserRow.TextColor = Colors.RGB(192,192,192)	'silver
				End If
			End If
		'End If

		If sl.SrcListNo <> sl.ListNo Then	'linked item 
			lblIndDSWPy.visible = False
			lblIndDSWPn.visible = False
			If mlrList.ListName = sl.Item Then
				' Linked listname
				lblIndDSWPrL.visible = True
				lblIndDSWPyL.visible = False
				lblIndDSWPnL.visible = False
			Else
				lblIndDSWPrL.visible = False
				If mlrList.DelSrcWhenPicked Then
					lblIndDSWPyL.visible = True
					lblIndDSWPnL.visible = False
				Else
					lblIndDSWPyL.visible = False
					lblIndDSWPnL.visible = True
				End If
			End If
		Else
			lblIndDSWPrL.visible = False
			lblIndDSWPyL.visible = False
			lblIndDSWPnL.visible = False
			If mlrList.DelSrcWhenPicked Then
				lblIndDSWPy.visible = True
				lblIndDSWPn.visible = False
			Else
				lblIndDSWPy.visible = False
				lblIndDSWPn.visible = True
			End If
		End If
		
		strExtraFile = Module1.ExtraFilename(mlrList.ListNo, sl.Item)
		If File.Exists(Starter.gstrDir, strExtraFile) Then
			strExtraFile = File.ReadString(Starter.gstrDir, strExtraFile)		
			If IsNumber(strExtraFile) Then
				btnUserRowExtra.Text = strExtraFile
			Else
				btnUserRowExtra.Text = ">"
				'btnUserRowExtra.Typeface = Typeface.DEFAULT_BOLD
			End If
			btnUserRowExtra.TextColor = Colors.Blue
		Else
			'btnUserRowExtra.Text = "+"
			'btnUserRowExtra.TextColor = Colors.Gray 
			'btnUserRowExtra.Typeface = Typeface.DEFAULT
		End If
		
		clvUserList.Add(pnl, 40dip)
	Next
	If clvUserList.GetSize > 0 Then
		'clvUserList.AsView.Height = Min(100%y, clvUserList.GetSize*41dip+1dip)	'stops bottom of scrn being all divider color. 41=40+divheight + 1 for last div
		If intSelectedIndex >= 0  Then
			Sleep(0)
			clvUserList.JumpToItem(intSelectedIndex)
			pnl = clvUserList.GetPanel(intSelectedIndex)
			pnl.SetColorAnimated(1000, Colors.RGB(255,140,0), Colors.White)			'dark orange  | 255,165,0=orange
		End If
	End If
	
End Sub
'
' Load list of other Lists to link/copy from
'
Sub LoadMenuLinkCopyItems(pblnExclEmptyLists As Boolean)

	Dim strLine As String
	Dim intItemsToGet As Int
	Dim lstMain As List = File.ReadList(Starter.gstrDir, Main.gstrMainList)
	Dim lstUser As List
	Dim mlrC As MainListRow = Main.glstSelectedLists.Get(0)
	Dim mlr As MainListRow
	
	clvPickList.Clear
	For intCnt1 = 0 To lstMain.Size-1
		strLine = lstMain.Get(intCnt1)
		mlr = Module1.ConvertStringToType_MainListRow(strLine)
		If mlr.ListNo <> mlrC.ListNo Then
			lstUser = File.ReadList(Starter.gstrDir, Module1.ListFilename(mlr.ListName))
			intItemsToGet = lstUser.Size
			If Not(mlr.DelSrcWhenPicked) Then
				lstUser = File.ReadList(Starter.gstrDir, Module1.PickedFilename(mlr.ListName))
				intItemsToGet = intItemsToGet - lstUser.Size
			End If
			If intItemsToGet > 0 Or Not(pblnExclEmptyLists) Then
				clvPickList.AddTextItem(mlr.ListName & " {" & intItemsToGet & "}",  mlr.ListName)
			End If
		End If
	Next
	If clvPickList.GetSize > 0 Then
		pnlPickList.Visible = True
		mblnPickListOpen = True
	End If
	
End Sub

Sub mnuAddNew_Click

	Dim lstUser As List
	Dim strParts() As String
	Dim strItem As String
	Dim intCnt1 As Int
	Dim intInsertAt As Int
	Dim intLoc As Int
	Dim mlr As MainListRow = Main.glstSelectedLists.Get(0)
	
	If Main.glstSelectedLists.Size > 1 Then
		MsgboxAsync("Cannot add to a Multi-list, add to source list", "")
		Wait For Msgbox_Result
		Return
	End If
	
'	If mlr.MasterList = "" Or Not(mlr.MasterImm) Then
		Wait For(libloc_MultilineInputDialog("", False)) Complete (strInput As String)
		If strInput <> "" And strInput <> QUOTE Then
			strParts = Regex.Split(CRLF, Module1.CleanItemName(strInput))
			lstUser = File.ReadList(Starter.gstrDir, Module1.ListFilename(mlr.ListName))
			For intCnt1 = strParts.Length-1 To 0 Step -1
				intInsertAt = 0
				strItem = Module1.CleanItemName(strParts(intCnt1))
				intLoc = strItem.LastIndexOf("..")			'can end .. or ..1|2 etc
				If intLoc > 0 Then	'And intLoc < strItem.Length-2 Then
					If intLoc = strItem.Length-2 Then
						intInsertAt = 999
						strItem = strItem.SubString2(0, intLoc)
					Else
						If IsNumber(strItem.SubString(intLoc+2)) Then
							intInsertAt = strItem.SubString(intLoc+2)
							If intInsertAt < 0 Then
								intInsertAt = 1
							else if intInsertAt > lstUser.Size Then
								intInsertAt = 999
							End If
							strItem = strItem.SubString2(0, intLoc)
						End If
					End If
				End If
				If lstUser.IndexOf(strItem) < 0 Then
					If intInsertAt = 0 Then
						lstUser.InsertAt(0, strItem)
					else if intInsertAt = 999 Then
						lstUser.Add(strItem)
					Else
						lstUser.InsertAt(intInsertAt-1, strItem)
					End If
				else if intInsertAt > 0 Then
					' Move existing item
					lstUser.RemoveAt(lstUser.IndexOf(strItem))
					If intInsertAt = 999 Then
						lstUser.Add(strItem)
					Else
						lstUser.InsertAt(intInsertAt-1, strItem)
					End If
				End If
			Next
			File.WriteList(Starter.gstrDir, Module1.ListFilename(mlr.ListName), lstUser)
			LoadList("", 0)
		End If
'	Else
'		clvUserList.Clear
'		clvUserList.AsView.Height = 41dip
'		clvUserList.AddTextItem("Loading...", "")
'		StartActivity(MasterList)
'	End If
	
End Sub

Sub mnuAddFromMaster_Click

	Dim mlr As MainListRow = Main.glstSelectedLists.Get(0)
	
	If Main.glstSelectedLists.Size > 1 Then
		MsgboxAsync("Cannot add to a Multi-list, add to source list", "")
		Wait For Msgbox_Result
		Return
	End If
	
	If mlr.MasterList <> "" Then
'		clvUserList.Clear
'		clvUserList.AsView.Height = 41dip
'		clvUserList.AddTextItem("Loading...", "")
		StartActivity(MasterList)
	End If
	
End Sub

Sub mnuAddAndLink_Click
	
	If Main.glstSelectedLists.Size > 1 Then
		MsgboxAsync("Cannot add to a Multi-list", "")
		Wait For Msgbox_Result
		Return
	End If

	gintLinkOrCopyType = LINKORCOPYTYPE_ADDANDLINKITEM
	LoadMenuLinkCopyItems(False)
	
End Sub

Sub mnuCopyItem_Click

	If Main.glstSelectedLists.Size > 1 Then
		MsgboxAsync("Cannot copy to a Multi-list", "")
		Wait For Msgbox_Result
		Return
	End If

	gintLinkOrCopyType = LINKORCOPYTYPE_COPYITEM
	LoadMenuLinkCopyItems(True)
	
End Sub

Sub mnuEditMaster_Click
	
	StartActivity(ModMasterList)
	
End Sub

Sub mnuLinkItem_Click
	
	If Main.glstSelectedLists.Size > 1 Then
		MsgboxAsync("Cannot link to a Multi-list", "")
		Wait For Msgbox_Result
		Return
	End If

	gintLinkOrCopyType = LINKORCOPYTYPE_LINKITEM
	LoadMenuLinkCopyItems(True)
	
End Sub

Sub mnuLinkList_Click
	
	If Main.glstSelectedLists.Size > 1 Then
		MsgboxAsync("Cannot link to a Multi-list", "")
		Wait For Msgbox_Result
		Return
	End If

	gintLinkOrCopyType = LINKORCOPYTYPE_LINKLIST
	LoadMenuLinkCopyItems(False)
	
End Sub

Sub mnuLoadListOrder_Click
	
	Main.gblnListSortNumerically = Not(Main.gblnListSortNumerically)
	LoadList("", 0)
	
End Sub

Sub mnuModUserList_Click
	
	StartActivity(ModUserList)
	
End Sub

Sub mnuSetVolume_Click

	pnlVolume.Visible = True
	
End Sub

Sub mnuVoiceAdd_Click

	mintQuestionNo = QU_NOTE		'jump to record note
	'SpeakTTS(mstrSpeech_Record & " item", "Record item")		
	ListenForSpeech
	
End Sub

Sub PE_TextToSpeechFinish (Intent As Intent)
	
    Dim jo As JavaObject = TTS1
	'Log("TTSF")
	Do While jo.RunMethod("isSpeaking",Null) = True
		'Log("TTSF isSpeaking")
		Sleep(250)
	Loop

	Dim listDummy As List
	'LibGen.lib_DebugLog("PE_TextToSpeechFinish", True)
	PlaylistDel
	listDummy.Initialize
	Questions(True, listDummy)
	
End Sub

Sub PickItem(pintIndex As Int)
	
	Dim lstUser As List
	Dim pnl As Panel = clvUserList.GetPanel(pintIndex)
	Dim lbl As Label = pnl.GetView(0)
	Dim sl As SortList = lbl.Tag
	Dim mlr As MainListRow = Main.glstAllLists.Get(sl.SrcListNo)

	' If linked item, handling of item (pick/grey vs remove) will be according to the items source list rules, not the displayed list rules
	If mlr.DelSrcWhenPicked Then
		RemoveItem(pintIndex, True)
	Else
		' Pick/unpick
		lstUser = File.ReadList(Starter.gstrDir, Module1.PickedFilename(mlr.ListName))
		If lstUser.IndexOf(lbl.Text) < 0 Then
			lstUser.Add(lbl.Text)
			lbl.TextColor = Colors.RGB(192,192,192)	'silver
		Else
			lstUser.RemoveAt(lstUser.IndexOf(lbl.Text))
			lbl.TextColor = Colors.RGB(mlr.R, mlr.G, mlr.B)
		End If
		File.WriteList(Starter.gstrDir, Module1.PickedFilename(mlr.ListName), lstUser)
	End If
	
End Sub

Sub PlaylistAdd

	'LibGen.lib_DebugLog("PlaylistAdd, mintPlaylistCnt=" & mintPlaylistCnt, True)
	If Not(LibGen.IsBluetoothHeadsetConnected) Then
		If mintPlaylistCnt <= 0 Then
			mintStartVolume = ph.GetVolume(ph.VOLUME_MUSIC)
			mintPlaylistCnt = 0
		End If
		mintPlaylistCnt = mintPlaylistCnt + 1
		ph.SetVolume(ph.VOLUME_MUSIC, skbVol.Value, False)
	End If
	
End Sub

Sub PlaylistDel

	'LibGen.lib_DebugLog("PlaylistDel, mintPlaylistCnt=" & mintPlaylistCnt, True)
	If Not(LibGen.IsBluetoothHeadsetConnected) Then
		mintPlaylistCnt = mintPlaylistCnt - 1
		If mintPlaylistCnt <= 0 Then
			ph.SetVolume(ph.VOLUME_MUSIC, mintStartVolume, False)
			mintPlaylistCnt = 0
		End If
	End If
		
End Sub

Sub Questions(pblnTextToSpeechFinished As Boolean, Texts As List)

	Dim strSpeech As String
	
	'LibGen.lib_DebugLog("Questions: QuNo=" & mintQuestionNo & ": TTSfinished=" & pblnTextToSpeechFinished & ": TextsSize=" & Texts.Size, True)
	If Not(pblnTextToSpeechFinished) Then
		If Texts.Size > 0 Then
			strSpeech = Texts.Get(0)
			strSpeech = strSpeech.ToLowerCase
		End If
		'LibGen.lib_DebugLog("Text0=" & strSpeech, True)
	End If
	If Not(pblnTextToSpeechFinished) And strSpeech = "cancel" Then
		mintQuestionNo = QU_STAYOPEN
		'SpeakTTS("Cancel", "")
	Else
		Select mintQuestionNo
			Case QU_END
				Activity.Finish
			Case QU_NOTE
				If pblnTextToSpeechFinished Then 	'(TTSfinished)
					ListenForSpeech
				Else								'(VRresult)
					Select strSpeech
						Case Else
							mstrMessage = Texts.Get(0)
							mintQuestionNo = QU_CONFNOTE		'skipping conf
							SpeakTTS(mstrMessage & ". Is this correct?", "")
					End Select
				End If
			Case QU_CONFNOTE
				If pblnTextToSpeechFinished Then 	'(TTSfinished)
					ListenForSpeech
				Else								'(VRresult)
					Select strSpeech
						Case "yes", "yes yes"	'sometimes it doesn't respond so I say yes again then get both
							VoiceAddItem(0)
							mintQuestionNo = QU_STAYOPEN
							SpeakTTS("Added", "")
						Case "end"
							VoiceAddItem(999)
							mintQuestionNo = QU_STAYOPEN
							SpeakTTS("Added", "")
						Case "more", "next", "add"
							VoiceAddItem(0)
							mintQuestionNo = QU_NOTE
							SpeakTTS("Added", "")
						Case "no"
							mintQuestionNo = QU_NOTE
							SpeakTTS(mstrSpeech_Record & " item", "Record item")		
						Case Else
							SpeakTTS(mstrMessage & ". Is this correct?", "")	'repeat
					End Select
				End If
		End Select
	End If
		
End Sub

Sub RemoveItem(pintIndex As Int, pblnWasPicked As Boolean)
	
	Dim blnDelExtra As Boolean
	Dim lstUser As List
	Dim pnl As Panel = clvUserList.GetPanel(pintIndex)
	Dim lbl As Label = pnl.GetView(0)
	Dim sl As SortList = lbl.Tag
	Dim mlr As MainListRow = Main.glstAllLists.Get(sl.ListNo)
	Dim intIndex As Int
	Dim strLookFor As String
	
	' Delete from this list (we don't delete from source if linked item, unless picked & DelSrcWhenPicked=True)
	lstUser = File.ReadList(Starter.gstrDir, Module1.ListFilename(mlr.ListName))
	If sl.SrcListNo <> sl.ListNo Then
		lstUser.RemoveAt(lstUser.IndexOf(lbl.Text & Chr(127) & sl.SrcListNo))
	Else
		lstUser.RemoveAt(lstUser.IndexOf(lbl.Text))
	End If
	File.WriteList(Starter.gstrDir, Module1.ListFilename(mlr.ListName), lstUser)
	
	If pblnWasPicked Then
		If sl.SrcListNo <> sl.ListNo Then
			' Delete picked item from source (sent to this proc by Pick as source list has DelSrcWhenPicked=True)
			mlr = Main.glstAllLists.Get(sl.SrcListNo)
			lstUser = File.ReadList(Starter.gstrDir, Module1.ListFilename(mlr.ListName))
			lstUser.RemoveAt(lstUser.IndexOf(lbl.Text))
			File.WriteList(Starter.gstrDir, Module1.ListFilename(mlr.ListName), lstUser)
		End If
		blnDelExtra = True
	Else
		If sl.SrcListNo = sl.ListNo Then
			blnDelExtra = True
		End If
	End If
	
	If blnDelExtra Then 
		Dim strExtraFile As String = Module1.ExtraFilename(mlr.ListNo, lbl.Text)
		If File.Exists(Starter.gstrDir, strExtraFile) Then
			If File.Exists(Starter.gstrDir, strExtraFile) Then
				File.Delete(Starter.gstrDir, strExtraFile)
			End If
		End If
		' Removed item from picked list if exists
		lstUser = File.ReadList(Starter.gstrDir, Module1.PickedFilename( mlr.ListName))
		If lstUser.IndexOf(lbl.Text) >=0 Then
			lstUser.RemoveAt(lstUser.IndexOf(lbl.Text))
		End If
		File.WriteList(Starter.gstrDir, Module1.PickedFilename(mlr.ListName), lstUser)

		' Del if exists linked in any other list
		strLookFor = lbl.Text & Chr(127) & sl.SrcListNo
		For intCnt1 = 0 To Main.glstAllLists.Size-1
			If intCnt1 <> sl.SrcListNo And intCnt1 <> sl.ListNo Then
				mlr = Main.glstAllLists.Get(intCnt1)
				If mlr.ListName <> Null Then
					lstUser = File.ReadList(Starter.gstrDir, Module1.ListFilename(mlr.ListName))
					intIndex = lstUser.IndexOf(strLookFor)
					If intIndex >=0 Then
						lstUser.RemoveAt(intIndex)
						File.WriteList(Starter.gstrDir, Module1.ListFilename(mlr.ListName), lstUser)
					End If
				End If
			End If
		Next
	End If
	
	clvUserList.RemoveAt(pintIndex)
	'clvUserList.AsView.Height = Min(100%y, clvUserList.GetSize*40dip+0dip)	'stops bottom of scrn being all divider color. 41=40+divheight + 1 for last div
	
End Sub

Sub skbVol_ValueChanged (Value As Int, UserChanged As Boolean)

	Log("skbVol_ValueChanged=" & Value & ", UserChanged=" & UserChanged)
	Log("skbVol.Max=" & skbVol.Max)
	Log("skbVol.Value=" & skbVol.Value)
	If UserChanged Then
		VolumeSetManual(Value)
		pnlVolume.Visible = False
	End If
	
End Sub

Sub SpeakTTS(pstrMessage As String, pstrToastMsg As String)

	If pstrToastMsg <> "" Then
		LibGen.lib_ToastMessage(pstrToastMsg, 2000, Colors.Black)
	Else
		LibGen.lib_ToastMessage(pstrMessage, 2000, Colors.Black)
	End If
	'ToastMessageShow(pstrMessage, True)
	'TTS1.SpeechRate = 0.75	'1=std, less is slower
	PlaylistAdd
	TTS1.Speak(pstrMessage, False)
	
End Sub

Sub SR_onResults(Texts As Object)
	'lblListening.Visible = False
	Questions(False, Texts)
End Sub
Sub SR_onError(ErrNo As Int)

    Select Case ErrNo
        Case 1
            Log("Error: " & ErrNo & " network timeout")
        Case 2
            Log("Error: " & ErrNo & " error network")
        Case 3
            Log("Error: " & ErrNo & " error audio recording")
        Case 4
            Log("Error: " & ErrNo & " error server")
        Case 5
            Log("Error: " & ErrNo & " error client")       
        Case 6
            Log("Error: " & ErrNo & " speech timeout")       
        Case 7
            Log("Error: " & ErrNo & " no match")		'timeout listening for speech (so what is err 6?)
	        ListenForSpeech
			Return
        Case 8
            Log("Error: " & ErrNo & " recognizer busy")
	        SR.stopListening
	        SR.destroy
	        SR.createSpeechRecognizer
	        ListenForSpeech
			Return
        Case 9
            Log("Error: " & ErrNo & " insufficient permissions")
        Case Else
            Log("Error: " & ErrNo & " Unknown error")
    End Select

	mintQuestionNo = QU_END
	'SpeakTTS("FAILED", "")
    
End Sub
Sub SR_onEndOfSpeech
    Log("SR_onEndOfSpeech")
End Sub

Sub VoiceAddItem(pintInsertAt As Int)
	
	Dim mlr As MainListRow
	Dim lstUser As List
	'Dim intCnt1 As Int
	'Dim intInsertAt As Int
	'Dim intInsertAtTest As Int
	'Dim strParts() As String
	
	If mblnCanVoiceAdd And mstrMessage <> "" Then
		mlr = Main.glstSelectedLists.Get(0)	
		lstUser = File.ReadList(Starter.gstrDir, Module1.ListFilename(mlr.ListName))
		mstrMessage = Module1.CleanItemName(mstrMessage)
		mstrMessage = mstrMessage.Replace(".", " dot ")		'google sometimes puts '.' not 'dot'

#if 1=0	
		'unreliable as google reinterprets what you say	**what about new speechtotext lib		
		strParts = Regex.Split(" ", mstrMessage.ToLowerCase)
		If strParts.Length > 2 Then
			If strParts(strParts.Length-2) = "dot" Then
				If strParts(strParts.Length-1) = "end" Then
					intInsertAt = 999
				Else
					intInsertAtTest = LibConv.lib_ConvertWordsToNumber(strParts(strParts.Length-1))
					If IsNumber(intInsertAtTest) Then
						If intInsertAtTest >= 0 Then
							intInsertAt = intInsertAtTest
							If intInsertAt > lstUser.Size Then
								intInsertAt = 999
							End If
						End If
					End If
				End If
				mstrMessage = ""
				For intCnt1 = 0 To strParts.Length-3
					If intCnt1 > 0 Then
						mstrMessage = mstrMessage & " "
					End If
					mstrMessage = mstrMessage & strParts(intCnt1)
				Next
			End If
		End If
#end if

		If pintInsertAt = 0 Then
			lstUser.InsertAt(0, mstrMessage)
		else if pintInsertAt = 999 Then
			lstUser.Add(mstrMessage)
		Else
			lstUser.InsertAt(pintInsertAt-1, mstrMessage)
		End If

		File.WriteList(Starter.gstrDir, Module1.ListFilename(mlr.ListName), lstUser)
		LoadList("", 0)
	End If
	
End Sub

Sub VolumeInitialise

	Dim ph As Phone					'lib Phone	
	Dim intVolume As Int
	Dim intMaxVolume As Int
	Dim lngLastVolDate As Long
	Dim prdDateDiff As Period
	Dim fltVolMult As Float		'% of max vol

	intMaxVolume = ph.GetMaxVolume(ph.VOLUME_MUSIC)
	fltVolMult = LibGen.lib_GetINIstring(False, "", "VolMult", "1")
	intVolume  = intMaxVolume * fltVolMult
	
	lngLastVolDate = LibGen.lib_GetINIstring(False, "", "LastVolDate", 0)
	prdDateDiff = DateUtils.PeriodBetweenInDays(lngLastVolDate, DateTime.Now)
	If prdDateDiff.Days = 0 And prdDateDiff.Hours = 0 And prdDateDiff.Minutes < 10 Then
		' If within 10mins of last time user changed vol, reload that
		intVolume = LibGen.lib_GetINIstring(False, "", "LastManVol", intVolume)
	Else
		' Else, reload what vol was (this wil exist if OS closed us, will have been cleared by user exit)
		intVolume = LibGen.lib_GetINIstring(False, "", "LastVol", intVolume)
	End If
	
	skbVol.Max = intMaxVolume
	skbVol.Value = intVolume
	LibGen.lib_SetINIstring(False, "", "LastVol", intVolume)
	skbVol.Visible = Not(LibGen.IsBluetoothHeadsetConnected)
	
End Sub

Sub VolumeSetManual(pintVolume As Int)

	LibGen.lib_SetINIstring(False, "", "LastManVol", pintVolume)
	LibGen.lib_SetINIstring(False, "", "LastVolDate", DateTime.Now)
	''LibGen.lib_DebugLog("DF=" & DateTime.TimeFormat, True)
	LibGen.lib_SetINIstring(False, "", "LastVolDateReadable", DateTime.Date(DateTime.Now) & " " & DateTime.Time(DateTime.Now))
		
End Sub

'Sub VR_Result(Success As Boolean, Texts As List)
'	
'	If Success = True Then
'		Questions(False, Texts)
'	Else
'		mintQuestionNo = QU_STAYOPEN	'QU_END
'		'SpeakTTS("FAILED", "")
'	End If
'	
'End Sub

'
' Because it uses async calls, it is a resumable sub, so can't simply return a value.
' Has to go in an activity module, so can't go in Lib module (which is static)
' Calling syntax: Wait For(libloc_MultilineInputDialog(False)) Complete (strInput As String)
' Returns: text if accepted, empty text if user cleared (or entered no text), QUOTE if user pressed back key (so do nothing)
' v3	- in some scenarios the kbd doesn't show without a delay, and sometimes pops up again after. added sleeps etc.
' v2c   - check for some text before setting SelectionStart to 1 (only gave err in one app at one time)
' v2b   - SelectionStart to put cursor at top
' v2a   - SetSize(92%) was 100% but on android10/S10e get white band
' v2    - StateManager
' v1.1a - descr chg only
'
Sub libloc_MultilineInputDialog(pstrText As String, pblnWrap As Boolean) As ResumableSub
	
	Dim cd As CustomLayoutDialog	'requires lib Dialogs
	
	cd.ShowAsync("", "Ok", "", "Clear", Null, True)
	cd.SetSize(92%x, 50%y) 'request maximum size
	Wait For Dialog_Ready (DialogPanel As Panel)
	Dim txt As EditText
	txt.Initialize("libloc_MultilineInputDialog")
	txt.SingleLine = False
	txt.Wrap = pblnWrap
	If pstrText = "" Then
		txt.Text = StateManager.GetSetting("Txt")
	Else
		txt.Text = pstrText
	End If
	txt.Color = Colors.RGB(224, 255, 255) 	'LightCyan
	txt.TextColor = Colors.Black
	txt.InputType = Bit.Or(txt.InputType, 524288)	'disable spellcheck
	txt.Gravity = Gravity.TOP + Gravity.LEFT
	If txt.Text.Length > 0 Then
		txt.SelectionStart = 1	'if don't set to 1 first it doesn't go to 0
	End If
	txt.SelectionStart = 0
	DialogPanel.AddView(txt, 0, 0, 92%x, 50%y)
	Dim ime As IME		'requires lib IME
	ime.Initialize("") 
	Sleep(100)			'seem to need longish sleep here to get kbd to show depending on what was done before calling this
	ime.ShowKeyboard(txt)
	Wait For Dialog_Result(Result As Int)
	Sleep(100)			'in some scenarios the kbd
	ime.HideKeyboard	'  pops up again after
	StateManager.SetSetting("Txt", "")
	StateManager.SaveSettings 
	If Result = DialogResponse.POSITIVE Then
		Return txt.Text
	else If Result = DialogResponse.NEGATIVE Then
		Return ""
	Else
		Return QUOTE	'flag to do nothing
	End If

End Sub
Sub libloc_MultilineInputDialog_TextChanged (Old As String, New As String)
	StateManager.SetSetting("Txt", New)
	StateManager.SaveSettings
End Sub
