﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=10.7
@EndOfDesignText@
' Cutdown copy of UserList, called when user clicks on a linked list in UserList
' Works with gstrUserListLinked rather than Main.glstSelectedLists
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: True
#End Region

Sub Process_Globals

End Sub

Sub Globals
	
	Private lblUserRow As Label
	Private btnUserRowExtra As Button
	Private clvUserList As CustomListView
	Private lblDivider As Label
	Private mintDblclickIndex As Int
	Private lblLinkInd As Label
	Private lblLinkIndDSWP As Label
	Private lblIndDSWPn As Label
	Private lblIndDSWPy As Label
	Private lblIndDSWPnL As Label
	Private lblIndDSWPyL As Label
	Private clvPickList As CustomListView
	Private pnlPickList As Panel
	Private mbytWaitClick As Byte

End Sub

Sub Activity_Create(FirstTime As Boolean)

End Sub

Sub Activity_Resume

	LoadList("", 0)
	
End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub

Sub Activity_KeyPress (KeyCode As Int) As Boolean 'Return True to consume the event
	
	If KeyCode = KeyCodes.KEYCODE_BACK Then
		UserList.gstrUserListLinked = ""
	End If
	Return False
	
End Sub

Sub btnUserRowExtra_Click

	Dim pnl As Panel = clvUserList.GetPanel(clvUserList.GetItemFromView(Sender))
	Dim lbl As Label = pnl.GetView(0)
	Dim btn As Button = pnl.GetView(1)
	Dim sl As SortList = lbl.Tag
	Dim mlr As MainListRow = Module1.MainListRow_FromListNo(sl.SrcListNo)
	Dim strExtraFile As String
	Dim strText As String

	strExtraFile = Module1.ExtraFilename(mlr.ListNo, lbl.Text)
	If File.Exists(Starter.gstrDir, strExtraFile) Then
		strText = File.ReadString(Starter.gstrDir, strExtraFile)
	End If
	
	Wait For(libloc_MultilineInputDialog(strText, True)) Complete (strInput As String)
	If strInput = "" Then
		If File.Exists(Starter.gstrDir, strExtraFile) Then
			File.Delete(Starter.gstrDir, strExtraFile)
		End If
		btn.Text = ""
		'btn.TextColor = Colors.Gray
		'btn.Typeface = Typeface.DEFAULT_BOLD
	Else if strInput <> QUOTE Then
		File.WriteString(Starter.gstrDir, strExtraFile, strInput)
		If IsNumber(strInput) Then
			btn.Text = strInput
		Else
			btn.Text = ">"
			'btn.Typeface = Typeface.DEFAULT_BOLD
		End If
		btn.TextColor = Colors.Blue
	End If
	
End Sub

Sub Handleclick(pintIndex As Int)

	' Sort sngclick from dblclick
	If mbytWaitClick = 1 Then
		mbytWaitClick = 2
		mintDblclickIndex = pintIndex
		Return
	End If
	
	mbytWaitClick = 1
	Sleep (250)

	Dim pnl As Panel = clvUserList.GetPanel(pintIndex)
	Dim lbl As Label = pnl.GetView(0)
	Dim sl As SortList = lbl.Tag
	Dim mlr As MainListRow = Module1.MainListRow_FromListNo(sl.SrcListNo)

	If sl.Item = mlr.ListName Then
		Return
	End If
     
	If mbytWaitClick = 1 Then
	Else
		' Pick
		If pintIndex = mintDblclickIndex Then
			PickItem(pintIndex)
		End If
	End If
	mbytWaitClick = 0

End Sub

Sub lblDivider_Click
	
	Handleclick(clvUserList.GetItemFromView(Sender))
	
End Sub
Sub lblDivider_LongClick
	
	RemoveItem(clvUserList.GetItemFromView(Sender), False)
	
End Sub

Sub lblUserRow_Click
	
	Handleclick(clvUserList.GetItemFromView(Sender))
	
End Sub
Sub lblUserRow_LongClick
	
	RemoveItem(clvUserList.GetItemFromView(Sender), False)
	
End Sub

Sub LoadList(pstrSelectItem As String, pintSelectListNo As Int)
	
	Dim blnOk As Boolean 
	Dim lstList As List
	Dim lstMaster As List
	Dim lstPicked As List
	Dim lstTemp As List
	Dim lstSelect As List
	Dim intCnt1 As Int
	Dim intCnt2 As Int
	Dim intLoc As Int 
	Dim strItem As String
	Dim strExtraFile As String
	Dim intSelectedIndex As Int = -1
	Dim pnl As Panel
	Dim mlrList As MainListRow			'list selected in main (this loop where multi)
	Dim mlrSource As MainListRow		'source list where item is a linked one
	
	Activity.LoadLayout("Userlist")
	clvUserList.Clear
	'clvUserList.AddTextItem("Loading...", "")
	'Sleep(0)
	mlrList = Module1.MainListRow_FromListName(UserList.gstrUserListLinked)
	Activity.Title = mlrList.ListAbbr
	
	lstList.Initialize
	lstTemp.Initialize
	mlrList = Module1.MainListRow_FromListName(UserList.gstrUserListLinked)
	lstTemp = File.ReadList(Starter.gstrDir,  Module1.ListFilename(mlrList.ListName))
	lstPicked = File.ReadList(Starter.gstrDir,  Module1.PickedFilename(mlrList.ListName))
	If mlrList.MasterList <> "" Then
		lstMaster = File.ReadList(Starter.gstrDir, Module1.ListFilename(mlrList.MasterList))
	End If
	intCnt2 = lstTemp.Size-1

	' Load lstList full of SortLists
	For intCnt1 = intCnt2 To 0 Step -1
		strItem = lstTemp.Get(intCnt1)
		blnOk = True
		Dim sl As SortList
		intLoc = strItem.IndexOf(Chr(127))	'is it a linked item
		If intLoc >= 0 Then
			' Linked item/listname
			sl.SrcListNo = strItem.SubString(intLoc+1)
			sl.ListNo = mlrList.ListNo
			sl.Item = strItem.SubString2(0, intLoc)
			
			' Check it still exists in source (provided not a linked listname)
			mlrSource = Module1.MainListRow_FromListNo(sl.SrcListNo)
			If sl.Item <> mlrSource.ListName Then
				lstSelect = File.ReadList(Starter.gstrDir, Module1.ListFilename(mlrSource.ListName))
				If lstSelect.IndexOf(sl.Item) < 0 Then
					lstTemp.RemoveAt(intCnt1)
					File.WriteList(Starter.gstrDir, Module1.ListFilename(mlrList.ListName), lstTemp)
					blnOk = False
				End If
			End If
		Else
			sl.ListNo = mlrList.ListNo
			sl.SrcListNo = mlrList.ListNo
			sl.Item = strItem
		End If
		
		If blnOk Then
			If mlrList.MasterList = "" Then
				sl.MasterIndex = -1
			Else
				sl.MasterIndex = lstMaster.IndexOf(sl.Item)
			End If
			lstList.InsertAt(0, sl)		'use this as we are viewing list
			'lstList.Add(sl)			' in reverse order
		End If
	Next

	If Main.gblnListSortNumerically Then
		lstList.SortType("MasterIndex", True)
	Else
		lstList.SortType("Item", True)
	End If
	
	clvUserList.Clear
	For intCnt1 = 0 To lstList.Size-1
		pnl.Initialize("")
		pnl.SetLayout(0, 0, clvUserList.AsView.Width, 40dip) 'set the panel size before you load the layout.
		pnl.LoadLayout("Userrow")
		pnl.Color = Colors.White
		sl = lstList.Get(intCnt1)
		lblUserRow.Text = sl.Item 
		lblUserRow.Tag = sl
		mlrList = Module1.MainListRow_FromListNo(sl.SrcListNo)
		lblUserRow.TextColor = Colors.RGB(mlrList.R, mlrList.G, mlrList.B)
		If sl.Item = pstrSelectItem And sl.SrcListNo = pintSelectListNo Then
			intSelectedIndex = intCnt1
		End If

		' Grey picked items from lists that don't remove picked items
		If Not(mlrList.DelSrcWhenPicked) Then
			lstPicked = File.ReadList(Starter.gstrDir, Module1.PickedFilename(mlrList.ListName))
			If lstPicked.IndexOf(sl.Item) >= 0 Then
				lblUserRow.TextColor = Colors.RGB(192,192,192)	'silver
			End If
		End If

		If sl.SrcListNo <> sl.ListNo Then	'linked item 
			lblIndDSWPy.visible = False
			lblIndDSWPn.visible = False
			If mlrList.DelSrcWhenPicked Then
				lblIndDSWPyL.visible = True
				lblIndDSWPnL.visible = False
			Else
				lblIndDSWPyL.visible = False
				lblIndDSWPnL.visible = True
			End If
		Else
			lblIndDSWPyL.visible = False
			lblIndDSWPnL.visible = False
			If mlrList.DelSrcWhenPicked Then
				lblIndDSWPy.visible = True
				lblIndDSWPn.visible = False
			Else
				lblIndDSWPy.visible = False
				lblIndDSWPn.visible = True
			End If
		End If
		
		strExtraFile = Module1.ExtraFilename(mlrList.ListNo, sl.Item)
		If File.Exists(Starter.gstrDir, strExtraFile) Then
			strExtraFile = File.ReadString(Starter.gstrDir, strExtraFile)		
			If IsNumber(strExtraFile) Then
				btnUserRowExtra.Text = strExtraFile
			Else
				btnUserRowExtra.Text = ">"
				'btnUserRowExtra.Typeface = Typeface.DEFAULT_BOLD
			End If
			btnUserRowExtra.TextColor = Colors.Blue
		Else
			'btnUserRowExtra.Text = "+"
			'btnUserRowExtra.TextColor = Colors.Gray 
			'btnUserRowExtra.Typeface = Typeface.DEFAULT
		End If
		
		clvUserList.Add(pnl, 40dip)
	Next
	If clvUserList.GetSize > 0 Then
		'clvUserList.AsView.Height = Min(100%y, clvUserList.GetSize*41dip+1dip)	'stops bottom of scrn being all divider color. 41=40+divheight + 1 for last div
		If intSelectedIndex >= 0  Then
			Sleep(0)
			clvUserList.JumpToItem(intSelectedIndex)
			pnl = clvUserList.GetPanel(intSelectedIndex)
			pnl.SetColorAnimated(1000, Colors.RGB(255,140,0), Colors.White)			'dark orange  | 255,165,0=orange
		End If
	End If
	
End Sub

Sub mnuLoadListOrder_Click
	
	Main.gblnListSortNumerically = Not(Main.gblnListSortNumerically)
	LoadList("", 0)
	
End Sub

Sub PickItem(pintIndex As Int)
	
	Dim lstUser As List
	Dim pnl As Panel = clvUserList.GetPanel(pintIndex)
	Dim lbl As Label = pnl.GetView(0)
	Dim sl As SortList = lbl.Tag
	Dim mlr As MainListRow = Module1.MainListRow_FromListNo(sl.SrcListNo)

	' If linked item, handling of item (pick/grey vs remove) will be according to the items source list rules, not the displayed list rules
	If mlr.DelSrcWhenPicked Then
		RemoveItem(pintIndex, True)
	Else
		' Pick/unpick
		lstUser = File.ReadList(Starter.gstrDir, Module1.PickedFilename(mlr.ListName))
		If lstUser.IndexOf(lbl.Text) < 0 Then
			lstUser.Add(lbl.Text)
			lbl.TextColor = Colors.RGB(192,192,192)	'silver
		Else
			lstUser.RemoveAt(lstUser.IndexOf(lbl.Text))
			lbl.TextColor = Colors.RGB(mlr.R, mlr.G, mlr.B)
		End If
		File.WriteList(Starter.gstrDir, Module1.PickedFilename(mlr.ListName), lstUser)
	End If
	
End Sub

Sub RemoveItem(pintIndex As Int, pblnWasPicked As Boolean)
	
	Dim blnDelExtra As Boolean
	Dim lstUser As List
	Dim pnl As Panel = clvUserList.GetPanel(pintIndex)
	Dim lbl As Label = pnl.GetView(0)
	Dim sl As SortList = lbl.Tag
	Dim mlr As MainListRow = Module1.MainListRow_FromListNo(sl.ListNo)
	Dim intIndex As Int
	Dim strLookFor As String
	
	' Delete from this list (we don't delete from source if linked item, unless picked & DelSrcWhenPicked=True)
	lstUser = File.ReadList(Starter.gstrDir, Module1.ListFilename(mlr.ListName))
	If sl.SrcListNo <> sl.ListNo Then
		lstUser.RemoveAt(lstUser.IndexOf(lbl.Text & Chr(127) & sl.SrcListNo))
	Else
		lstUser.RemoveAt(lstUser.IndexOf(lbl.Text))
	End If
	File.WriteList(Starter.gstrDir, Module1.ListFilename(mlr.ListName), lstUser)
	
	If pblnWasPicked Then
		If sl.SrcListNo <> sl.ListNo Then
			' Delete picked item from source (sent to this proc by Pick as source list has DelSrcWhenPicked=True)
			mlr = Module1.MainListRow_FromListNo(sl.SrcListNo)
			lstUser = File.ReadList(Starter.gstrDir, Module1.ListFilename(mlr.ListName))
			lstUser.RemoveAt(lstUser.IndexOf(lbl.Text))
			File.WriteList(Starter.gstrDir, Module1.ListFilename(mlr.ListName), lstUser)
		End If
		blnDelExtra = True
	Else
		If sl.SrcListNo = sl.ListNo Then
			blnDelExtra = True
		End If
	End If
	
	If blnDelExtra Then 
		Dim strExtraFile As String = Module1.ExtraFilename(mlr.ListNo, lbl.Text)
		If File.Exists(Starter.gstrDir, strExtraFile) Then
			If File.Exists(Starter.gstrDir, strExtraFile) Then
				File.Delete(Starter.gstrDir, strExtraFile)
			End If
		End If
		' Removed item from picked list if exists
		lstUser = File.ReadList(Starter.gstrDir, Module1.PickedFilename( mlr.ListName))
		If lstUser.IndexOf(lbl.Text) >=0 Then
			lstUser.RemoveAt(lstUser.IndexOf(lbl.Text))
		End If
		File.WriteList(Starter.gstrDir, Module1.PickedFilename(mlr.ListName), lstUser)

		' Del if exists linked in any other list
		strLookFor = lbl.Text & Chr(127) & sl.SrcListNo
		For intCnt1 = 0 To Main.glstAllLists.Size-1
			If intCnt1 <> sl.SrcListNo And intCnt1 <> sl.ListNo Then
				mlr = Main.glstAllLists.Get(intCnt1)
				If mlr.ListName <> Null Then
					lstUser = File.ReadList(Starter.gstrDir, Module1.ListFilename(mlr.ListName))
					intIndex = lstUser.IndexOf(strLookFor)
					If intIndex >=0 Then
						lstUser.RemoveAt(intIndex)
						File.WriteList(Starter.gstrDir, Module1.ListFilename(mlr.ListName), lstUser)
					End If
				End If
			End If
		Next
	End If
	
	clvUserList.RemoveAt(pintIndex)
	'clvUserList.AsView.Height = Min(100%y, clvUserList.GetSize*40dip+0dip)	'stops bottom of scrn being all divider color. 41=40+divheight + 1 for last div
	
End Sub

'
' Because it uses async calls, it is a resumable sub, so can't simply return a value.
' Has to go in an activity module, so can't go in Lib module (which is static)
' Calling syntax: Wait For(libloc_MultilineInputDialog(False)) Complete (strInput As String)
' Returns: text if accepted, empty text if user cleared (or entered no text), QUOTE if user pressed back key (so do nothing)
' v3	- in some scenarios the kbd doesn't show without a delay, and sometimes pops up again after. added sleeps etc.
' v2c   - check for some text before setting SelectionStart to 1 (only gave err in one app at one time)
' v2b   - SelectionStart to put cursor at top
' v2a   - SetSize(92%) was 100% but on android10/S10e get white band
' v2    - StateManager
' v1.1a - descr chg only
'
Sub libloc_MultilineInputDialog(pstrText As String, pblnWrap As Boolean) As ResumableSub
	
	Dim cd As CustomLayoutDialog	'requires lib Dialogs
	
	cd.ShowAsync("", "Ok", "", "Clear", Null, True)
	cd.SetSize(92%x, 50%y) 'request maximum size
	Wait For Dialog_Ready (DialogPanel As Panel)
	Dim txt As EditText
	txt.Initialize("libloc_MultilineInputDialog")
	txt.SingleLine = False
	txt.Wrap = pblnWrap
	If pstrText = "" Then
		txt.Text = StateManager.GetSetting("Txt")
	Else
		txt.Text = pstrText
	End If
	txt.Color = Colors.RGB(224, 255, 255) 	'LightCyan
	txt.TextColor = Colors.Black
	txt.InputType = Bit.Or(txt.InputType, 524288)	'disable spellcheck
	txt.Gravity = Gravity.TOP + Gravity.LEFT
	If txt.Text.Length > 0 Then
		txt.SelectionStart = 1	'if don't set to 1 first it doesn't go to 0
	End If
	txt.SelectionStart = 0
	DialogPanel.AddView(txt, 0, 0, 92%x, 50%y)
	Dim ime As IME		'requires lib IME
	ime.Initialize("") 
	Sleep(100)			'seem to need longish sleep here to get kbd to show depending on what was done before calling this
	ime.ShowKeyboard(txt)
	Wait For Dialog_Result(Result As Int)
	Sleep(100)			'in some scenarios the kbd
	ime.HideKeyboard	'  pops up again after
	StateManager.SetSetting("Txt", "")
	StateManager.SaveSettings 
	If Result = DialogResponse.POSITIVE Then
		Return txt.Text
	else If Result = DialogResponse.NEGATIVE Then
		Return ""
	Else
		Return QUOTE	'flag to do nothing
	End If

End Sub
Sub libloc_MultilineInputDialog_TextChanged (Old As String, New As String)
	StateManager.SetSetting("Txt", New)
	StateManager.SaveSettings
End Sub
