﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=8.3
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: True
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Dim n As Notification
End Sub
Sub Service_Create
	'LibGen.lib_DebugLog("Service_Create", True)
	'Service.AutomaticForegroundMode=Service.AUTOMATIC_FOREGROUND_NEVER
End Sub

Sub Service_Start (StartingIntent As Intent)
	'If StartingIntent.HasExtra("android.intent.action.BOOT_COMPLETED") Then
	'If StartingIntent.HasExtra("android.intent.extra.ALARM_COUNT") Then
	Dim mapReminders As Map
	Dim intCnt1 As Int
	Dim dt As Long = DateTime.Now
	Dim dtFirstReminder As Long
	Dim intNotifNo As Int
	'Dim strDebug As String
	
	mapReminders.Initialize
	If File.Exists(Starter.gstrDir, Starter.gstrRemindersIni) Then
		mapReminders = File.ReadMap(Starter.gstrDir, Starter.gstrRemindersIni)
	End If
	'strDebug = "SS: Service_Start: at " & DateTime.Date(DateTime.Now) & " " & DateTime.Time(DateTime.Now) & CRLF _
	'  & "Starter.gstrAppName=" & Starter.gstrAppName & CRLF & "Starter.gstrDir=" & Starter.gstrDir & CRLF & "Starter.gstrRemindersIni=" & Starter.gstrRemindersIni & CRLF _
	'  & "StartingIntent.ExtrasToString=" & StartingIntent.ExtrasToString & CRLF & "mapReminders.Size=" & mapReminders.Size
	'LibGen.lib_DebugLog(strDebug, True)
	'LibGen.lib_WriteToTextFile(File.DirRootExternal, "_debug.txt", True, strDebug)
	If mapReminders.Size > 0 Then
		For intCnt1 = mapReminders.Size -1 To 0 Step -1
			'LibGen.lib_DebugLog("intCnt1=" & intCnt1, True)
			dt = mapReminders.GetValueAt(intCnt1)
			If dt <= DateTime.Now Then
				intNotifNo = Rnd(1,999)
				'LibGen.lib_DebugLog("SS: mapRems.Value(" & dt & ")=" & DateTime.Date(dt) & " " & DateTime.Time(dt) & " is < now, issuing notification (" & intNotifNo & ")", True)
				n.Initialize
				'LibGen.lib_DebugLog("SS: n.IsInitialized=" & n.IsInitialized, True)
				n.Icon="icon"
				n.OnGoingEvent=False
				n.AutoCancel=False
				'n.Insistent=False
				'n.Number = intNotifNo
				n.Sound=False
				n.Vibrate=False
				n.Light=True
				'n.SetInfo("Reminder", mapReminders.GetKeyAt(intCnt1),"")
				n.SetInfo2(Starter.gstrAppName, mapReminders.GetKeyAt(intCnt1), intNotifNo & ":" & mapReminders.GetKeyAt(intCnt1), "Main")
				'LibGen.lib_DebugLog("SS: Notify(" & intNotifNo & ")", True)
				n.Notify(intNotifNo)	'need sep nums or overwrites. using randon as if start app afresh whilest outstanding notis, may overwrite
				'LibGen.lib_DebugLog("SS: remove mapReminders.Size=" & mapReminders.Size, True)
				mapReminders.Remove(mapReminders.GetKeyAt(intCnt1))
				'LibGen.lib_DebugLog("SS: remove mapReminders.Size=" & mapReminders.Size, True)
				File.WriteMap(Starter.gstrDir, Starter.gstrRemindersIni, mapReminders)
			Else
				'LibGen.lib_DebugLog("SS: mapRems.Key(" & dt & ")=" & DateTime.Date(dt) & " " & DateTime.Time(dt) & " is > now", True)
				If dt < dtFirstReminder Or dtFirstReminder = 0 Then
					dtFirstReminder = dt
				End If
			End If
		Next
		If mapReminders.Size > 0 Then
			'strDebug = "SS: Restarting service at " & DateTime.Date(dtFirstReminder) & " " & DateTime.Time(dtFirstReminder)
			'LibGen.lib_DebugLog(strDebug, True)
			'LibGen.lib_WriteToTextFile(File.DirRootExternal, "_debug.txt", True, strDebug & CRLF)
			'StartServiceAt(Me,DateTime.Now+Main.SVCSECS*DateTime.TicksPerSecond,True)
			StartServiceAt(Me, dtFirstReminder, True)
		Else
			'strDebug = "SS: Stopping service"
			'LibGen.lib_DebugLog(strDebug, True)
			'LibGen.lib_WriteToTextFile(File.DirRootExternal, "_debug.txt", True, strDebug & CRLF)
			StopService(Me)
		End If
	End If
	Service.StopAutomaticForeground
	
End Sub

Sub Service_Destroy
	'LibGen.lib_DebugLog("Service_Destroy", True)
End Sub
