﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=8.5
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: True
#End Region

Sub Process_Globals

End Sub

Sub Globals
	
	Private chkSelUserRow As CheckBox
	Private lblSelUserRow As Label
	Private clvSelUserList as CustomListView
	Private lblDivider As Label
	Private mblnLoadingList As Boolean

End Sub

Sub Activity_Create(FirstTime As Boolean)

	LoadList
	
End Sub

Sub Activity_Resume

End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub

Sub chkSelUserRow_CheckedChange(Checked As Boolean)

	If Not(mblnLoadingList) Then
		Dim intIndex As Int = clvSelUserList.GetItemFromView(Sender)
		Dim pnl As Panel = clvSelUserList.GetPanel(intIndex)
		Dim lbl As Label = pnl.GetView(1)
		SaveSelection(lbl.Text, pnl.Tag, Checked)
	End If
	
End Sub

Sub lblSelUserRow_Click

	Dim intIndex As Int = clvSelUserList.GetItemFromView(Sender)
	Dim pnl As Panel = clvSelUserList.GetPanel(intIndex)
	Dim chk As CheckBox = pnl.GetView(0)
	
	chk.Checked = Not(chk.Checked)
	Dim lbl As Label = pnl.GetView(1)
	SaveSelection(lbl.Text, pnl.Tag, chk.Checked)
	
End Sub

Sub LoadList()
	
	Dim lstSrc As List
	Dim lstTgt As List
	Dim lstPicked As List
	Dim intCnt1 As Int
	Dim intListNo As Int
	Dim intLoc As Int
	Dim pnl As Panel
	Dim mlrSrc As MainListRow = Module1.MainListRow_FromListName(Main.gstrSelectedList)
	Dim mlrTgt As MainListRow = Main.glstSelectedLists.Get(0)
	Dim mlrSrcSrc As MainListRow 

	mblnLoadingList = True
	Activity.LoadLayout("SelUserlist")
	clvSelUserList.Clear
	clvSelUserList.AddTextItem("Loading...", "")
	Sleep(0)
	If Main.glstSelectedLists.Size > 1 Then
		Activity.Finish
	Else
		Activity.Title = mlrSrc.ListAbbr
	End If

	lstSrc = File.ReadList(Starter.gstrDir, Module1.ListFilename(mlrSrc.ListName))
	lstTgt = File.ReadList(Starter.gstrDir, Module1.ListFilename(mlrTgt.ListName))
	
	clvSelUserList.Clear
	For intCnt1 = 0 To lstSrc.Size-1
		pnl.Initialize("")
		pnl.SetLayout(0, 0, clvSelUserList.AsView.Width, 40dip) 'set the panel size before you load the layout.
		pnl.LoadLayout("SelUserRow")
		lblSelUserRow.Text = lstSrc.Get(intCnt1)
		lblSelUserRow.TextColor = Colors.RGB(mlrSrc.R, mlrSrc.G, mlrSrc.B)

		' Grey picked items from lists that don't remove picked items
		intLoc = lblSelUserRow.Text.IndexOf(Chr(127))		'is it a linked item
		If intLoc >= 0 Then
			intListNo = lblSelUserRow.Text.SubString(intLoc+1)
			mlrSrcSrc = Module1.MainListRow_FromListNo(intListNo)
			If Not(mlrSrcSrc.DelSrcWhenPicked) Then
				lstPicked = File.ReadList(Starter.gstrDir, Module1.PickedFilename(mlrSrcSrc.ListName))
				If lstPicked.IndexOf(lblSelUserRow.Text.SubString2(0, intLoc)) >= 0 Then
					lblSelUserRow.TextColor = Colors.RGB(192,192,192)	'silver
				End If
			End If
			chkSelUserRow.Checked = (lstTgt.IndexOf(lstSrc.Get(intCnt1)) >= 0)
			pnl.Tag = intListNo
		Else
			If Not(mlrSrc.DelSrcWhenPicked) Then
				lstPicked = File.ReadList(Starter.gstrDir, Module1.PickedFilename(mlrSrc.ListName))
				If lstPicked.IndexOf(lstSrc.Get(intCnt1)) >= 0 Then
					lblSelUserRow.TextColor = Colors.RGB(192,192,192)	'silver
				End If
			End If
			chkSelUserRow.Checked = (lstTgt.IndexOf(lstSrc.Get(intCnt1) & Chr(127) & mlrSrc.ListNo) >= 0)
			pnl.Tag = mlrSrc.ListNo
		End If
				
		pnl.Color = Colors.White
		clvSelUserList.Add(pnl, 40dip)
	Next
	mblnLoadingList = False
	
End Sub

Sub SaveSelection(pstrItem As String, pintSrcListNo As Int, pblnCheck As Boolean)
	
	Dim lstTgt As List
	Dim strLine As String
	Dim mlrTgt As MainListRow = Main.glstSelectedLists.Get(0)
	
	lstTgt = File.ReadList(Starter.gstrDir, Module1.ListFilename(mlrTgt.ListName))
	If pstrItem.IndexOf(Chr(127)) >= 0 Then
		strLine = pstrItem
	Else
		strLine = pstrItem & Chr(127) & pintSrcListNo
	End If
	
	If lstTgt.indexof(strLine) >=0 Then
		If Not(pblnCheck) Then
			lstTgt.RemoveAt(lstTgt.indexof(strLine))
		End If
	Else
		If pblnCheck Then
			lstTgt.InsertAt(0, strLine)
		End If
	End If
	File.WriteList(Starter.gstrDir, Module1.ListFilename(mlrTgt.ListName), lstTgt)
	
End Sub

Sub SaveSelections
	
	Dim lstUser As List
	Dim pnl As Panel
	Dim lbl As Label
	Dim chk As CheckBox
	Dim strLine As String
	Dim intLoc As Int
	Dim mlrSelect As MainListRow = Module1.MainListRow_FromListName(Main.gstrSelectedList)
	Dim mlrUser As MainListRow = Main.glstSelectedLists.Get(0)
	
	lstUser = File.ReadList(Starter.gstrDir, Module1.ListFilename(mlrUser.ListName))
	
	' Activity_Create/LoadList preticked everything already linked, now for simplicity, remove all links to selected list and re-add those ticked now
	For intCnt1 = lstUser.Size-1 To 0 Step -1
		strLine = lstUser.Get(intCnt1)
		If strLine.StartsWith(Chr(127) & mlrSelect.ListNo) Then
			lstUser.RemoveAt(intCnt1)
		End If
	Next
	
	For intCnt1 = 0 To clvSelUserList.GetSize-1
		pnl = clvSelUserList.GetPanel(intCnt1)
		chk = pnl.GetView(0)
		lbl = pnl.GetView(1)
		If chk.Checked Then
			intLoc = lbl.Text.IndexOf(Chr(127))		'is it already a linked item
			If intLoc >= 0 Then			
				' Is it self a linked item so use info that points to its source list
				lstUser.InsertAt(0, lbl.Text)
				'lstUser.Add(lbl.Text)
			Else
				lstUser.InsertAt(0, lbl.Text & Chr(127) & mlrSelect.ListNo)
				'lstUser.Add(lbl.Text & Chr(127) & mlrSelect.ListNo)
			End If
		End If
	Next
	File.WriteList(Starter.gstrDir, Module1.ListFilename(mlrUser.ListName), lstUser)
	
End Sub
